/*
 * Copyright 2012 Tri-Edge AI <triedgeai@gmail.com>
 * All rights reserved. Distributed under the terms of the MIT license.
 */

long __a64l_map[] = {
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, // 0x00
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, // 0x10
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1, // 0x20
	 2,  3,  4,  5,  6,  7,  8,  9, 10, 11,  0,  0,  0,  0,  0,  0, // 0x30
	 0, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, // 0x40
	27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37,  0,  0,  0,  0,  0, // 0x50
	 0, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, // 0x60
	53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63,  0,  0,  0,  0,  0, // 0x70
	 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0  // 0x80
};

long
a64l(const char* s)
{
	long result = 0;
	
	// Unrolled for maximum performance.
	
	if (s[0] == '\0')
		return 0;
	
	result = __a64l_map[s[0]];
	
	if (s[1] == '\0')
		return result;
		
	result += __a64l_map[s[1]] * (64);
	
	if (s[2] == '\0')
		return result;
		
	result += __a64l_map[s[2]] * (64 * 64);
	
	if (s[3] == '\0')
		return result;
		
	result += __a64l_map[s[3]] * (64 * 64 * 64);
	
	if (s[4] == '\0')
		return result;
		
	result += __a64l_map[s[4]] * (64 * 64 * 64 * 64);
	
	if (s[5] == '\0')
		return result;
		
	result += __a64l_map[s[5]] * (64 * 64 * 64 * 64 * 64);
	
	return result;
}
