/*
 * Copyright 2012 Tri-Edge AI <triedgeai@gmail.com>
 * All rights reserved. Distributed under the terms of the MIT license.
 */

char __l64a_result_empty[1] = "";
char __l64a_result[7] = "......";

char __l64a_map[] = {
	'.','/',
	
	'0','1','2','3','4','5','6','7','8','9',
	
	'A','B','C','D','E','F','G','H','I','G','K','L','M','N','O','P','Q','R',
	'S','T','U','V','W','X','Y','Z',
	
	'a','b','c','d','e','f','g','h','i','g','k','l','m','n','o','p','q','r',
	's','t','u','v','w','x','y','z'
};

char*
l64a(long value)
{
	// Only the low-order 32 bits should be used. In case long > 4 bytes.
	
	if (sizeof(long) > 4) {
		value &= 0xFFFFFFFF;
	}
	
	// Unrolled for maximum performance.
	
	if (value == 0) {
		return __l64a_result_empty;
	}

	__l64a_result[0] = __l64a_map[value % 64];
	value /= 64;
	
	if (value == 0) {
		__l64a_result[1] = '\0';
		return __l64a_result;
	}
	
	__l64a_result[1] = __l64a_map[value % 64];
	value /= 64;
	
	if (value == 0) {
		__l64a_result[2] = '\0';
		return __l64a_result;
	}
	
	__l64a_result[2] = __l64a_map[value % 64];
	value /= 64;
	
	if (value == 0) {
		__l64a_result[3] = '\0';
		return __l64a_result;
	}
	
	__l64a_result[3] = __l64a_map[value % 64];
	value /= 64;
	
	if (value == 0) {
		__l64a_result[4] = '\0';
		return __l64a_result;
	}
	
	__l64a_result[4] = __l64a_map[value % 64];
	value /= 64;
	
	if (value == 0) {
		__l64a_result[5] = '\0';
		return __l64a_result;
	}
	
	__l64a_result[5] = __l64a_map[value % 64];
	
	return __l64a_result;
}
